#line 1 "C:/_MikroC/_MesProjets_MikroC/_Max7219_4_matrice8x8/RTC_DS1307_I2Cx.c"
#line 1 "c:/_mikroc/_mesprojets_mikroc/_max7219_4_matrice8x8/rtc_ds1307_i2cx.h"
#line 23 "c:/_mikroc/_mesprojets_mikroc/_max7219_4_matrice8x8/rtc_ds1307_i2cx.h"
extern int dummy;
extern unsigned char Date[];
extern unsigned char Time[];
extern int DS1307_Started ;
extern unsigned char sec, min1, hr, week_day, day, month, year,ctrl;




void Write_DS1307(unsigned char addresse, unsigned char dd) ;
unsigned char Read_DS1307(unsigned char address) ;
void Start_DS1307(void);
void Stop_DS1307(void);
void Init_DS1307(void);
void Write_Date_Time(char *sec, char *min, char *hr, char *week_day, char *day, char *mn, char *year) ;
void Read_Date_Time(char *sec, char *min, char *hr, char *week_day, char *day, char *mn, char *year) ;
void Transform_Time(char *sec, char *min, char *hr, char *week_day, char *day, char *mn, char *year);
void Prepare_Display_Time(char sec, char min, char hr, char week_day, char day, char mn, char year);
#line 51 "C:/_MikroC/_MesProjets_MikroC/_Max7219_4_matrice8x8/RTC_DS1307_I2Cx.c"
void Write_DS1307(unsigned char addresse, unsigned char dd)
{
int i;
 I2C_Start();
  I2C2_Wr ( 0xD0 );
  I2C2_Wr (addresse);
  I2C2_Wr (dd);
  I2C2_Repeated_Start ();



 for(i=0;i<3;i++)
 {
 if ( I2C2_Wr ( 0xD0 )==1)
 {
  I2C2_Start ();
 } else
 break;
 }
  I2C2_Stop ();
 }

 unsigned char Read_DS1307(unsigned char address)
{
  I2C2_Start ();
  I2C2_Wr ( 0xD0 );
  I2C2_Wr (address);
  I2C2_Start ();
  I2C2_Wr ( 0xD0 +1);
 dummy= I2C2_Rd (0);
  I2C2_Stop ();
 return(dummy);
}


void Start_DS1307()
{

 if (DS1307_Started) return ;
 dummy = Read_DS1307(0) & ~0x80;
 Write_DS1307(0,dummy);
 DS1307_Started = 1;
}

void Stop_DS1307()
{
 dummy = Read_DS1307(0) | 0x80;
 Write_DS1307(0,dummy);
 DS1307_Started = 0;
}

void Init_DS1307()
{
 if (Read_DS1307(0x3E)==0x20) return;
 Start_DS1307();

 Write_DS1307(2,Read_DS1307(2) & ~(1<<6) );
 Write_DS1307(0,0x00 & 0x7F);
 Write_DS1307(1,0x59);
 Write_DS1307(2,0x23 & ~(1<<6) );
 Write_DS1307(3,0x07);
 Write_DS1307(4,0x28);
 Write_DS1307(5,0x12);
 Write_DS1307(6,0x16);
 Write_DS1307(0x3E,0x20);

}

void Write_Date_Time(char *sec, char *min, char *hr, char *week_day, char *day, char *month, char *year)
{
  I2C2_Start ();
  I2C2_Wr ( 0xD0 );
  I2C2_Wr (0);
  I2C2_Wr (0x80+ sec);
  I2C2_Wr (min);
  I2C2_Wr (hr);
  I2C2_Wr (week_day);
  I2C2_Wr (day);
  I2C2_Wr (month);
  I2C2_Wr (year);

  I2C2_Stop ();
  I2C2_Start ();
 Delay_ms(10);
  I2C2_Wr ( 0xD0 );
  I2C2_Wr (0);
  I2C2_Wr (0);
  I2C2_Stop ();
}

void Read_Date_Time(char *sec, char *min, char *hr, char *week_day, char *day, char *month, char *year)
{
  I2C2_Start ();
  I2C2_Wr ( 0xD0 );
  I2C2_Wr (0);
  I2C2_Repeated_Start ();
  I2C2_Wr ( 0xD0 +1);
 *sec = I2C2_Rd (1);
 *min = I2C2_Rd (1);
 *hr = I2C2_Rd (1);
 *week_day = I2C2_Rd (1);
 *day = I2C2_Rd (1);
 *month= I2C2_Rd (1);
 *year = I2C2_Rd (0);
  I2C2_Stop ();
}

void Transform_Time(char *sec, char *min, char *hr, char *week_day, char *day, char *month, char *year)
{
 *sec = ((*sec & 0x70) >> 4)*10 + (*sec & 0x0F);
 *min = ((*min & 0xF0) >> 4)*10 + (*min & 0x0F);
 *hr = ((*hr & 0x30) >> 4)*10 + (*hr & 0x0F);
 *week_day =(*week_day & 0x07);
 *day = ((*day & 0xF0) >> 4)*10 + (*day & 0x0F);
 *month = ((*month& 0x10) >> 4)*10 + (*month& 0x0F);
 *year = ((*year & 0xF0)>>4)*10+(*year & 0x0F);
}

void Prepare_Display_Time(char sec, char min, char hr, char week_day, char day, char monthn, char year)
{
 Date[0]=(day / 10) + 48;
 Date[1]= (day % 10) + 48;
 Date[2]='/';
 Date[3]=(month/ 10) + 48;
 Date[4]=(month% 10) + 48;
 Date[5]='/';
 Date[6]='2';
 Date[7]='0';
 Date[8]=(year / 10) + 48;
 Date[9]=(year % 10) + 48;
 Date[10]=0;

 Time[0]=(hr / 10) + 48;
 Time[1]=(hr % 10) + 48;
 Time[2]=':';
 Time[3]=(min / 10) + 48;
 Time[4]=(min % 10) + 48;
 Time[5]=':';
 Time[6]=(sec / 10) + 48;
 Time[7]=(sec % 10) + 48;
 Time[8]=0;
}
