
 #define VERSION "161230"
 //modif hardware:  Rajout R=2,7K pull-Down sur sortie RC0=CS
 // evite l'illumination complete des afficheurs  la mise sous tension
 // enlev l'init RTC par defaut
 
 // reamenagement pour choix
 // Msg
 // Date Time
 // temper
 
 //#define VERSION "161229"     // speciale jour de l'An 2017

 #define Version2
//  Rajout decompte HMS du jour de l'An
// #define VERSION "161228"level !
//   Probleme mesure LM335 .. tres variable ???
// modif : RA2=-Vref=2,5V
// capteur LM335 -50 +100 sur RA0= EA0
// 2730mV at 0C    2930mV at 20C
// -Vref=2500mV=VCC/2
// delta= 2,5V pour 1024 bits
// mesures releves sur LM335
// VCC = 4,940 V    -Vref sur RA2 = 2.470V   Mesure RA0=2.923V
//_PIC_calculs_datas_2016.xls   LM335


//The LM335 operates from -40C to +100C
#define EA0_MAE 0.2422  // Ax   Pente par Pts
#define  EA0_Offset -28.1 // +b    offset C      -23.1 theoric

//#define VERSION "161223"
#define DIRECTORY  "C:\_MikroC\_MesProjets_MikroC\_Max7219_4_matrice8x8"
#define PROJECT "18F46K22_MAX7219_4x_Mat_8x8_SPI1_Softw_LM335.mcppi"
#define SOURCE "18F46K22_test_Max71219_4xMatrice8x8_SOFT_SPI_LM335"
#define EEPROM  "18F46K22_MAX7219_4x_Mat_8x8_SPI1_Softw_EEPROM.ihex"

#define PROCESSOR "18F46K22"
#define POWER_SUPPLY 5V

#define FOSC_INTERNE
#define FOSC 16.0  //8 MHz
#define BAUD 19200  // UART1
#define Langage  Mikroc V 6.6.3
#define Timer1_LOW
#define SOFTWARE_SPI1
//#define HARDWARE_SPI1
// #define DEBUGGING

//HARDWARE module

 #define With_UART1
// UART RC6 =TX=fil blanc   RC7= RX=fil vert  Interface Prolific LTTL/USB  -> COM12 19200  -> PC XP  VBray 2014
// librairies utilises:
// UART , C_String   C_Stdlib   Conversions , I2C
// EEPROM :

/* Config bit  :
C:\_MikroC\_MesProjets_MikroC\_Max7219_4_matrice8x8\18F46K22_FOSC_Interne_8MHz
CONFIG1H : $300001 : 0x0028
CONFIG2L : $300002 : 0x001E
CONFIG2H : $300003 : 0x003C
CONFIG3H : $300005 : 0x0098
CONFIG4L : $300006 : 0x0080
CONFIG5L : $300008 : 0x000F
CONFIG5H : $300009 : 0x00C0
CONFIG6L : $30000A : 0x000F
CONFIG6H : $30000B : 0x00E0
CONFIG7L : $30000C : 0x000F
CONFIG7H : $30000D : 0x0040


  // ac:pinout_18f46k22
  
 //   ac:Max7219_DS
 
 // ac:P18F46K22_SPI_link
   
 HARDWARE :
Miniinthebox 5281696500001
MAX7219 matricielle 8 * 8 en srie interfac huit chiffres a conduit pilote d'affichage pour Arduino
 #02816965   3.91 euros
 Disolay Leds 8x8 1088AS
                                          RTC DS1307
                                                   1 SQ
                                                   2 DS
I2C2      SCL2 sur RD0   Pin 19   ------ vert ---- 3 SCL
I2C2      SDA2 sur RD1   Pin 20   ------ jaune --- 4 SDA
=5v -------------------------------------orange ---5 VCC
0V Gnd -----------------------------------marron --6 GND

+5V                               ------- Pin 1  MAX7219 #1 Module 8x8 -  MAX7219 #2- -- MAX7219 #3---- MAX7219 #4
0V Gnd                            ------- Pin 2  MAX7219 #1 Module 8x8 -  MAX7219 #2- -- MAX7219 #3---- MAX7219 #4
SPI1      SDO      RC5   pin 24   ------- Pin 3  MAX7219 #1 Module 8x8 -  MAX7219 #2- -- MAX7219 #3---- MAX7219 #4
SPI1      SDIN     RC4   pin 23   not used
Select             RC0   pin 15   ------- Pin 4  MAX7219 #1 Module 8x8 -  MAX7219 #2- -- MAX7219 #3---- MAX7219 #4
SPI1      CLCK     RC3   pin 18   ------- Pin 5  MAX7219 #1 Module 8x8 -  MAX7219 #2- -- MAX7219 #3---- MAX7219 #4

UART1 TX  sur RC6        pin 25  --- blanc  RX cordon Prolix
UART1 RX  sur RC7        pin 26   --- vert  TX cordon Prolix
Gnd 0V  ------------------------------ noir  Gnd Cordon Prolix
                                  N.C. --rouge +5V USB
                                  
 // module BlueTooth Linvor (VERT ) @=20:13:01:24:11:22
 // JY-MCU   Power 3,3  6V
 //                                          Pin 6   STATE
 //UART1 .. 25  RC6 --- R=750---fil vert --> Pin 5   TXD  3,3V
 //UART1 .. 26  RC7 ------------fil blanc<---Pin 4   RXD
//                   0V Gnd ----fil noir---- Pin 3   GND
//                   +5V -------fil rouge ---Pin 2   VCC
//                                           Pin 1  KEY

UART2 TX  sur ED6        pin 29
UART2 RX  sur RD7        pin 30

+VCC ----------------------R=2,7K ----Pin1 LM3335   Alim
RA0       Entree Analog  pin 2        Pin2 du LM335  Output
0V -------------------R 100K -------- Pin 3 du LM335 adjust
Diviseur par 2   +VCC --- 2,7K --|- 2,7K ---- 0V
RA2    Entree -VREF  ------------|

*/

#include "built_in.h"     // for  Hi  Lo ..etc


#define CLS 12
#define CR 13
#define LF 10
#define TAB 9
#define BACK 8
#define Separator 0x20   // space

#define NbCycles_T1 8       // nb d'interrupot pour faire 1 seconde

sbit Led_Rouge at LATA5_bit;
sbit Led_Rouge_Direction  at TRISA5_bit;

sbit  SPI_CS   at LATC0_bit;
sbit  SPI_CS_direction   at TRISC0_bit;
/* SPI bit bang
sbit  SPI_clk  at LATC3_bit;
sbit  SPI_Out at LATC5_bit;
sbit  SPI_clk_direction  at TRISC3_bit;
sbit  SPI_Out_direction  at TRISC5_bit;
*/

// Software SPI module connections
sbit SoftSpi_SDI at RC4_bit;
sbit SoftSpi_SDO at RC5_bit;
sbit SoftSpi_CLK at RC3_bit;

sbit SoftSpi_SDI_Direction at TRISC4_bit;
sbit SoftSpi_SDO_Direction at TRISC5_bit;
sbit SoftSpi_CLK_Direction at TRISC3_bit;

const code char mesg0[]=" Mikroc 7.0.0 "PROCESSOR" \r\n";
const code char mesg1[]=" Directory : "DIRECTORY" \r\n";
const code char mesg2[]=" Projet : "PROJECT"r\n";
const code char mesg3[]=" Source : "SOURCE"_"VERSION".c \r\n";
const code char mesg4[]=" Module Matrice 8x8 avec MAX7129 + capteur LM335\r\n";
const code char mesg5[]=" Saisir un nouveau Msg avec le terminal via <Msg=xxxx>\r\n";
const code char mesg6[]=" Mode Temperature avec <TEMP_ON> ou <TEMP_OFF>\r\n";
const code char mesg7[]= "Messages en EEPROM avec cde : <EEPROM=0> ..  15 \r\n";
const code char mesg8[]= "*Bonne ANNEE 2017 a Tous*";
const code char mesg9[]= "    ";

const code char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4,mesg5,mesg6,mesg7,mesg8,mesg9};

#define MAXLEN1 128
volatile unsigned char buffer1[MAXLEN1];
volatile int Flag_Buffer1;
volatile  unsigned char c1;
volatile unsigned int i1;
volatile int Index1;
volatile unsigned int CptErr;

static int Flag_Timer1;
static unsigned int Cpt1;
static unsigned int Max_Timer1;

unsigned int i,j,k,l,m,n;
unsigned  char TEXTE[80]; // pour teste quelconque
unsigned char TEXTE2[80]; // pour temperature Amb
unsigned char * txt;
unsigned char * txt2;
unsigned char *p;

char CRam1[64];   // for flot2asccii use

unsigned int EAnx,EAn0,EAn1;
unsigned int SEAn0,SEAn1;
int nM;
unsigned char N1;
unsigned char  addr,donnee;
unsigned int Etat;
unsigned int clk;
unsigned long OverFlow_Timer0;
unsigned long L1,L2;
unsigned char Cpt=0;

float f1,f2,ff;

// MAX7129 matrice 8x8
unsigned char Aff_buffer[80];  //  8*8=64 + eventuell string terminator=0
unsigned Display_32x8_Pixel[256];
unsigned int Speed=100;

volatile struct chbits {   // 8 flags
     unsigned FrameErr:1;
     unsigned Over:1;
     unsigned RTC_Initialise: 1;
     unsigned FLT:1;
     unsigned PPS:1;
     unsigned Temper:1;
     unsigned Elapsed_Time:1;
     unsigned Mesure:1;
     unsigned First_Run:1;
   }Drapeaux ;
   
unsigned char sec, min1, hr, week_day, day, month, year,ctrl;
char  tnum[4];
int dummy;
unsigned char Date[12];     // dd/mm/20yy\0
unsigned char Time[9];      // hh:mn:ss\0
unsigned char DateTime[9];
unsigned char  DS1307_Started ;

#include "../common/timelib.h"
TimeStruct ts1, ts2 ,ts3;
long epoch=0L ;
long epoch1=0L ;
long epoch2=0L ;
long Ecart=0L ;
unsigned char NbH=0;
unsigned char NbM=0;
unsigned char NbS=0;
char Val_Ecart[15];
char Val_epoch1[15];
char Val_epoch2[15];

// ---------------------------------------

void Init_Hardware(void) ;
void Read_Msg_Eeprom( int depuis);
void Write_Msg_Eeprom( int Adr,const char * d1) ;

void Init_Timer1 (void);  //  timer 100mS * Max_timer1
void Arme_Timer1(void);   //
void Init_Timer0 (void);  //  counter in RA4 input
void strConstRamCpy(unsigned char *dest, const code char *source);
void UART1_Write_CText(const char *txt);
void RAZ_UART1(void);
unsigned char *Float2Ascii (float x, unsigned char *chaine,char precision) ;
void CRLF1(void)  ;
void Read_Msg64_Eeprom( unsigned char * T,int depuis);

#include "Interruptions.h"
#define With_I2C2
#define DS1307 0xD0
#include "RTC_DS1307_I2Cx.h"

 void Read_Msg64_Eeprom(unsigned char *T, int debut)
{   int i1 ,i;
  i1=0;
  do
  {
  i = EEPROM_Read(i1+debut);
  if ( i==0) break;
  if ( i1>63) break;
  //UART1_Write(i);
  *(T+i1)=i;
  Delay_ms(1);
  i1++;
   }
  while (i!=0) ;
  *(T+i1-1)=0;
 }


// --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF1()
{
 UART1_Write(CR);
 UART1_Write(LF);
}

void UART1_Write_CText(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
}


void Float2Ascii (float x, unsigned char *str,char precision)
{
 /* converts a floating point number to an ascii string */
 /* x is stored into str, which should be at least 30 chars long */
 int ie, i, k, ndig;
 double y;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;
 /* if x negative, write minus and reverse */
 if ( x < 0)
 {
   *str++ = '-';
   x = -x;
 }
 /* put x in range 1 <= x < 10 */
 if (x > 0.0) while (x < 1.0)
 {
   x *= 10.0;                // a la place de =*
   ie--;
 }
 while (x >= 10.0)
 {
   x = x/10.0;
   ie++;
 }
 // in f format, number of digits is related to size
 ndig += ie;                                // a la place de =+
 //round. x is between 1 and 10 and ndig will be printed to
 // right of decimal point so rounding is ...
 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
   k = x;
   *str++ = k + '0';
   if (i ==  ie ) *str++ = '.';
   x -= (y=k);
   x *= 10.0;
  }
 *str = '\0';
}


 void Init_Hardware()
{
  PORTA = 0b00111111;
  ANSELA=0;
  ANSELA.ANSA0=1;    //  analog input on Port A   voir page 154
  ANSELA.ANSA1=1;
  TRISA = 0b00011111 ;   // PORTA is RA0,1= analog input  RA2=anaolg -Vref,  RA3,  RA4=Input  RA5,6=Digital output
  Led_Rouge_Direction=0;
  Led_Rouge=0;
  CCP5CON=0;

  PORTB = 0xFF;
  TRISB = 0x83;    //  B0,B1 as input   ATTENTION B7 B6 for ICSP Pickit3
  ANSELB=0;

  PORTC = 0x00;          // RC0..RC5,RC7 = input RC6=Output
  ANSELC=0;
  TRISC = 0xFF;    //
  TRISC.TRISC7 = 1;  // RX - UART1
  TRISC.TRISC6 = 0;  // TX - UART1
  
  // specific SPI bit bang
  SPI_CS_direction=0;
  SPI_CS=1;
 /*
  SPI_clk_direction=0;
  SPI_Out_direction=0;
  SPI_clk=0;
  SPI_Out=0;
 */

  PORTD=0;
  ANSELD=0;
  TRISD=0xFF;
  TRISD.TRISD0 = 0;  // SCL I2C2
  TRISC.TRISD1 = 1;  // SDA I2C2
  TRISD.TRISD6 = 0;  // TX UART2
  TRISC.TRISD7 = 1;  // RX UART2

  SLRCON=0; // standard rate for PORTA,B,C,D,E
 }

void Init_ADC()
 {
 VREFCON0.FVREN=0;  // Fixed Voltage Reference is disabled
 VREFCON0.FVRS1=1; //   10 = Fixed Voltage Reference Peripheral output is 2x (2.048V)(1)
 VREFCON0.FVRS0=0;
       //config lecture ADC 10 bits
 ADCON0.ADON=1;      // ADC enabled , chanel 0
 ADCON1.TRIGSEL=0 ; // trigger from CCP5
 ADCON1.PVCFG1=0;   // +Vref = +5V AVdd
 ADCON1.PVCFG0=0;
 ADCON1.NVCFG1=0;   // -Vref = Entree externe RA2 = 2,5V
 ADCON1.NVCFG0=1;
// ADCON1.NVCFG1=0;   // -Vref = Gnd AVss
// ADCON1.NVCFG0=0;
 ADCON2.ADFM=1;     // right justified
 ADCON2.ACQT2=1;
 ADCON2.ACQT1=1;
 ADCON2.ACQT0=0;    // 16 TAD
 ADCON2.ADCS1=1;    //
 ADCON2.ADCS2=0;    //
 ADCON2.ADCS0=0;    // Fosc/32
 }

 unsigned int Read_ADCx(unsigned char Canal)  // for 18F45K22
{   unsigned int Ex;
    if (Canal > 7) return 0;
    ADCON0 |= Canal <<2;
    Delay_ms(5);
    ADCON0.GO_DONE = 1;//Start A/D Conversion
    _asm NOP ;
    _asm NOP ;
    while(ADCON0.GO_DONE ==1);//Loop here until A/D conversion completes
     _asm NOP ;
      _asm NOP ;
    Ex=ADRESL;
    Ex=Ex + (ADRESH <<8);
    return Ex;
 }
 

void RAZ_UART1()
{
    for (i1=0;i1<MAXLEN1;i1++) buffer1[i1]=0;
    i1=0;
    Index1=0;
    c1=RC1REG;
    c1=0;
    Flag_Buffer1 =0;
    RC1IE_bit = 1;
}


void Init_Timer0(void)
{
   // init en compteur sur entree RA4
  T08BIT_bit=0; // mode 16 bits
  T0CS_bit=1;  // mode comptage sur pin T0CKI= RA4
  T0SE_bit=1; // front edge
  PSA_bit=1; //  1= Not use of prescaler => 1/1 , because, if used prescaler minimum is 1/2
  T0PS2_bit=0; // prescaler 1/2
  T0PS1_bit=0;
  T0PS0_bit=0;
  TMR0H = 0;
  TMR0L = 0;
  TMR0IP_bit=1;   // high priority
  TMR0IF_bit=0;
  TMR0IE_bit=1;
  OverFlow_Timer0=0;
  TMR0ON_bit=1;
}

void Arme_Timer1(void)
{
   // 100mS * Max_Timer1
  TMR1IF_bit         = 0;
  TMR1H         = 0x0B;
  TMR1L         = 0xDC;
  Cpt1=0;
  Flag_Timer1=0;
  TMR1ON_bit=1;     // Timer0 ON
  TMR1IE_bit= 1;
  }


void Init_Timer1(void)
 {
//FOSC=16Mhz  Prescaler 1:8; TMR1 Preload = 3035; Actual Interrupt Time : 125 ms
  T1CON         = 0x00;
  TMR1CS1_bit=0; // FOSC/4
  TMR1CS0_bit=0;
  T1RD16_bit=1;
  T1CKPS1_bit=1;  //Prescaler 1:8
  T1CKPS0_bit=1;
  TMR1H  = 0x0B;
  TMR1L  = 0xDC;
   TMR1IF_bit  = 0;
  #ifdef Timer1_LOW
  TMR1IP_bit=0;   // low level interrupt
  #else
  TMR1IP_bit=1;   // low level interrupt
  #endif
  Cpt1=0;
  Flag_Timer1=0;
  TMR1ON_bit=0;
  TMR1IE_bit =0;
}

 #include "SPI_MAX7219_4_Matrice_8x8.inc"
 /*
 void SPI_Write_To_7219(unsigned char adr, unsigned char d1, unsigned char d2);
 void Clear_Matrice(void) ;
 void Affiche_Char(unsigned char c, unsigned int v);
 void Init_Module_Max7129_8x8(void);
 void Affiche_Text_Matrice(unsigned char *p, unsigned int V);
 void Affiche_CText_Matrice(const unsigned char *p, unsigned int V);
*/



void MAJ_RTC()
{ int m,l,j,i;
  m=2; // passe par dessus "U;"
  j=0;

   CRLF1();
   l=strlen(buffer1);
   WordToStr(l,CRam1);
   UART1_Write_Text(CRam1);
   CRLF1();
  // U;28;12;16;03;21;59#
    if ((buffer1[0]=='U')&& (buffer1[19]=='#') && (l>=20) )
     {
         UART1_Write_CText("\n\rMise a l'heure RTC :");
         UART1_Write_Text(buffer1);
         CRLF1();
          for (i=2;i<l;i++)
          {
            if(buffer1[i]==';')
              {
                buffer1[i]=0;
                DateTime[j]=atoi(buffer1+i-2);
                j++;
              }
          }// for i
       // ne pas oublier le dernier!
        buffer1[19]=0; // elimine le # en fin de chaine
        DateTime[j]=(buffer1[17]-48)*10 + buffer1[18]-48;
        day=Dec2Bcd(DateTime[0]);
        month=Dec2Bcd(DateTime[1]);
        year=Dec2Bcd(DateTime[2]);
        week_day=Dec2Bcd(DateTime[3]); // jour de la semaine sur 1 seul digit
        hr=Dec2Bcd(DateTime[4]);
        min1=Dec2Bcd(DateTime[5]);
        sec=0;
        CRLF1();
        /*  pour debugging
        UART1_Write_CText("\r\nSaisie : \r\n");
       for (i=0;i<6;i++)
       {
        ByteToStr(DateTime[i],CRam1);
        UART1_Write_Text(CRam1);
        CRLF1();
       }

       */
       
            sec= 0;
            CRLF1();
            Stop_DS1307();
            Write_Date_Time(sec,min1,hr,week_day,day,month,year);
            UART1_Write_CText("\n\r RTC Updated \r\n");
            Start_DS1307();
     }// if buff1[0]='U'
 }



void main()
{

  #ifdef FOSC_INTERNE
  OSCCON = 0b01110010  ; //0x72 ;     //Oscillateur  16Mhz
  //OSCCON = 0b01100010  ; //0x62 ;     //Oscillateur  8Mhz
  OSCTUNE=0;
  OSCTUNE.PLLEN=0;
  OSCCON2=0;
  //while (OSCCON.HFIOFS==0); // wait stable oscillator
  #else
  // Q=20Mhz
  #endif
   Delay_ms(1000);

  Init_Hardware() ;
  SPI_CS=1;
  Max_Timer1=8;
  Led_Rouge=0;

  UART1_Init(19200);
  Delay_ms(100);
  UART1_Write(CLS);   // Erase screen terminal  :it is an option on Vbray Terminal!
  Delay_ms(500);

  txt=&TEXTE[0];
  txt2=&TEXTE2[0];
   CRLF1();
  // presentation sur UART1
  UART1_Write_CText ("Presentation : \r\n");
  for(i=0;i<7;i++)
  {
  
    UART1_Write_CText(Messages[i]);
   }
  Delay_ms(2000);
  CRLF1();


  clk = Clock_kHz();
  strConstRamCpy(txt,"\r\nClock initiale in  =  ...  Khz \r\n");
  WordToStr(clk,CRam1);
  memcpy(txt+ 23,CRam1,5);
  UART1_Write_Text(txt);
  DS1307_Started=0;

 // ==========  Test zone =========================
    I2C2_Init(400000);
    UART1_Write_CText("Init I2C2 400Khz pour RTC DS1307 \r\n");
    Init_DS1307();
    Start_DS1307();
    Delay_ms(500);
 //    Write_Date_Time(0x45,0x49,0x23,0x03, 0x31,0x12,0x16);
 //   Delay_ms(100);
    Read_Date_Time(&sec,&min1,&hr,&week_day,&day,&month,&year);      // read time from RTC(DS1307)
    Transform_Time(&sec,&min1,&hr,&week_day,&day,&month,&year); // format date and time
    Prepare_Display_Time( sec, min1,hr, week_day,  day, month,  year );
    UART1_Write_CText("DS1307 Date :");
    UART1_Write_Text(Date);
    UART1_Write_CText(" Time: ");
    UART1_Write_Text(Time);
    CRLF1();
    Delay_ms(2000);

  ts1.ss = 0 ;
  ts1.mn = 59 ;
  ts1.hh = 23 ;
  ts1.md = 30 ;
  ts1.mo = 12 ;
  ts1.yy = 2016 ;
  ts2.ss = 00 ;
  ts2.mn = 00 ;
  ts2.hh = 00 ;
  ts2.md = 01 ;
  ts2.mo = 01 ;
  ts2.yy = 2017 ;
  
   UART1_Write_CText("Date &t1 debut 2016/12/30 23H59M00S =");
  epoch1 = Time_dateToEpoch(&ts1) ;
  LongWordToStr(epoch1,CRam1);
  UART1_Write_Text(CRam1);
  CRLF1()  ;
  UART1_Write_CText("Date &t2  Fin  2017/01/01 00H00M00S= ");
   epoch2 = Time_dateToEpoch(&ts2) ;
  LongWordToStr(epoch2,CRam1);
  UART1_Write_Text(CRam1);
  CRLF1()  ;

  UART1_Write_CText("Difference =");
  Ecart = Time_dateDiff(&ts1, &ts2) ;
  LongWordToStr(Ecart,CRam1);
  UART1_Write_Text(CRam1);
  CRLF1();

 // =========================================  */


  #ifdef Timer1_LOW
  TMR1IP_bit=0;   // low level interrupt
  #else
  TMR1IP_bit=1;   // low level interrupt
  #endif

   UART1_Write_CText("init ADC EA0 et -VREF=2,5V sur RA2 \r\n" )  ;
   Init_ADC();
   
   UART1_Write_CText("init SOFT SPI  RC3=Clk ,RC5=Dout  RC0=CS -> MAx7219:\r\n" )  ;
   Soft_SPI_Init();
   Init_Module_4_Max7129_8x8();
   UART1_Write_CText("Clear Matrice 2x 8x8\r\n" )  ;
   Clear_Matrices() ;

   PEIE_bit=1;
   RCON.IPEN = 1;       // enable priority levels  , car TMR1 => low interrupt
   PEIE_bit = 1;          // Enable Peripheral interrupt
   GIE_bit  = 1;         // Enable Global interrupt
   
   UART1_Write_CText("Init et test interrupt Timer1  8 x 125 msec soit 2 sec \r\n" );
   Max_Timer1=8;
   Init_Timer1();
   Arme_Timer1();
   TXREG1='$';
   CRLF1();
   while(Flag_Timer1==0);
   TXREG1='#';
   CRLF1();
  
    UART1_Write_CText("Display <0123456789> sur matrices Leds \r\n");
    Clear_Matrices() ;
    Affiche_CText_Matrice("    ",1);
    Affiche_CText_Matrice("0123456789", 5);
    Led_Rouge=~Led_Rouge;
    Delay_ms(1000);
    Led_Rouge=~Led_Rouge;
    
    txt=&TEXTE[0];
    strConstRamCpy(txt,"    ");
     
    Drapeaux.Temper=0 ; // inactif par defaut
    Cpt=0;
    Speed=40;   // par defaut
    RAZ_UART1();  // init Interrupt UART1
    
    while (1)
    {
     Clear_Matrices() ;
     Affiche_CText_Matrice("    ", 1);


    txt2=&TEXTE[0];
    Read_Date_Time(&sec,&min1,&hr,&week_day,&day,&month,&year);      // read time from RTC(DS1307)
    Transform_Time(&sec,&min1,&hr,&week_day,&day,&month,&year); // format date and time
    Prepare_Display_Time( sec, min1,hr, week_day,  day, month,  year );


    ts2.ss = 59 ;
    ts2.mn = 59 ;
    ts2.hh = 23 ;
    ts2.md = 31 ;
    ts2.mo = 12 ;
    ts2.yy = 2016 ;
    
    
    ts1.ss = sec ;
    ts1.mn = min1 ;
    ts1.hh = hr ;
    ts1.md = day ;
    ts1.mo = month ;
    ts1.yy = 2000+year ;
    
    txt2=&TEXTE2[0];
    strcpy(txt2,Date);
    k=strlen(txt2);
    strcat(txt2+k," ");
    k=strlen(txt2);
    strcat(txt2+k,Time);
    
    UART1_Write_CText("Date &t1 Now ");
    UART1_Write_Text(txt2);
    UART1_Write_CText(" =>:");
    epoch1 = Time_dateToEpoch(&ts1) ;
    LongWordToStr(epoch1,CRam1);
    UART1_Write_Text(CRam1);
    CRLF1()  ;

    UART1_Write_CText("Date &T2 Fin = 31/12/16 23:59:59 => :" );
    epoch2 = Time_dateToEpoch(&ts2) ;
    LongToStr(epoch2,CRam1);      // entier long sign !!
    UART1_Write_Text(CRam1);
    CRLF1()  ;
    
    Ecart = Time_dateDiff(&ts1, &ts2) ;
    UART1_Write_CText("                      Difference =>");
    LongToStr(Ecart, Val_Ecart);
    Ltrim(Val_Ecart);
    UART1_Write_Text(Val_Ecart);
    CRLF1();

     if ((Ecart<4) && (Ecart> -120))
    {
    Max_Timer1=1;
    strConstRamCpy(txt2,"    Bonne Annee 2017.Bonne Sante.Big Bisous");
    UART1_Write_Text(txt2);CRLF1();
    strConstRamCpy(txt,"....");
    Affiche_Text_Matrice(txt2,20);
    }
    if ((Ecart>4) && (Ecart < 300))     // 5 mn avant
    {
     Max_Timer1=2;
     txt2=&TEXTE2[0];
     strConstRamCpy(txt2," >> ");
     strcat(txt2,Val_Ecart);
     strcat(txt2,".");
     strConstRamCpy(txt,"..");
    // Affiche_Text_Matrice(txt2, Speed);
    }
     else
     {
     Max_Timer1=10;
    txt2=&TEXTE2[0];
    strcpy(txt2,Date);
    k=strlen(txt2);
    strcat(txt2+k," ");
      k=strlen(txt2);
    strcat(txt2+k,Time);
    }

    
    if ((Drapeaux.Temper==1) &&(Cpt & 0x01)==1)
     {
      Max_Timer1=10;
     Clear_Matrices() ;
     Affiche_CText_Matrice("    ", 1);
     txt2=&TEXTE2[0];
     strConstRamCpy(txt2,"T=");
     k=strlen(txt2);
     EAn0= Read_ADCx(0);
    // k=ADC_Read(0);   // ne marche pas avec des references tensions autres que VCC et GnD
    // -Vref=2,500V
    // mesure =20500V at -21;3C    2,730V at 0C    3,730V at 100C
    // pour debugging
     UART1_Write_Text(txt2);
     WordToStr(EAn0,CRam1);
     UART1_Write_Text(CRam1);
     UART1_Write_CText(" pts  ");
     f1=((float)EAn0*EA0_MAE)+EA0_Offset;
     Float2Ascii (f1,CRam1,1);
     strcat(txt2+k,CRam1);
      k=strlen(txt2);
     strConstRamCpy(txt2+k,"C");
     UART1_Write_Text(txt2);  CRLF1();
     k=strlen(txt2);
     for(i=0;i<k;i++)  if(*(txt2+i)=='') *(txt2+i)=126;
    // Affiche_Text_Matrice(txt2, Speed);
     }
     

     UART1_Write_CText("Compteur= ");
     ByteToStr(Cpt,CRam1);
     UART1_Write_Text(CRam1)  ;
     UART1_Write(TAB);


     if ((Cpt & 0x01)==1)
     {
        Affiche_Text_Matrice(txt2,20);
        UART1_Write('1');
       }
        else
       {
        Affiche_Text_Matrice(txt, 10);
        UART1_Write('0');
     }
     CRLF1();

    Cpt++;
     
    Init_Timer1();
    Arme_Timer1();
    while((Flag_Timer1==0) && ( Flag_Buffer1==0));
    
    // test si reception de commande venant du terminal (UART1)
    if (Flag_Buffer1==1)
    {
       p= strstr(buffer1,"Msg=");  // p pointer result
       if ((p>0) && (strlen(buffer1)>6))
       {
        k=strlen(buffer1);
        if ((k>6) && (k<84))
         {
           UART1_Write_Text("\r\nhello, i get your Msg!");
           UART1_Write_Text(buffer1+4);CRLF1();
           strcpy(txt,buffer1+4);
          }
       }  //p
       p= strstr(buffer1,"TEMP_ON");  // p pointer result
       if (p>0)
       {
        Drapeaux.Temper=1;
        k=strlen(buffer1);
        UART1_Write_CText("\r\nOK, Temper is ON!\r\n");
       } //p
       p= strstr(buffer1,"TEMP_OFF");  // p pointer result
       if (p>0)
       {
        Drapeaux.Temper=0;
        UART1_Write_CText("\r\nOK, Temper is OFF!\r\nRetour au display txt \r\n");
       } //p
       p= strstr(buffer1,"Speed=");  // p pointer result
       if (p>0)
       {
         k=strlen(buffer1);
         if(k>6)
         {
           #ifdef DEBUGGING
           // test si tous les digits sont des chiffres
          CRLF1();UART1_Write_Text(buffer1+6);CRLF1();
          #endif
          m=0;
          for (i=0;i<(k-6);i++)
          {
             if ((*(buffer1+6+i)>='0')&&(*(buffer1+6+i)<='9'))  m++;
          }
          if (m==(k-6))
          {
          n= atoi(buffer1+6);
          #ifdef DEBUGGING
            UART1_Write_CText("\r\n m= ");
            WordToStr(n,CRam1);
            UART1_Write_Text(CRam1);CRLF1();
          #endif
           if ((n>1)&&(n<512)) Speed=n;
           UART1_Write_CText("\r\nChange Speed To ");
           WordToStr(Speed,CRam1);
           UART1_Write_Text(CRam1);CRLF1();
          }
         }
         #ifdef DEBUGGING
          UART1_Write_CText("\r\n m= ");
          WordToStr(m,CRam1);
          UART1_Write_Text(CRam1);CRLF1();
         #endif
       } //p
       p= strstr(buffer1,"EEPROM=");  // p pointer result
       if (p>0)
       {
         k=strlen(buffer1);
         if((k>7)&&(k<10))
         {
          m=0;
          for (i=0;i<(k-7);i++)
          {
             if ((*(buffer1+7+i)>='0')&&(*(buffer1+7+i)<='9'))  m++;
          }
          if (m==(k-7))
          {
            n= atoi(buffer1+7);
        //  #ifdef DEBUGGING
            UART1_Write_CText("\r\n m= ");
            WordToStr(n,CRam1);
            UART1_Write_Text(CRam1);UART1_Write(TAB);
        //  #endif
           if ((n>=0)&&(n<16)) 
           {
           k=n<<6;
        //  #ifdef DEBUGGING
           UART1_Write_CText("  Eeprom Msg adresse ");
           WordToHex(k,CRam1);
           UART1_Write_Text(CRam1);CRLF1();
         //  #endif
            Read_Msg64_Eeprom(txt,k);
            }
          }
         }
       } //p
       
       if ((buffer1[0]=='U') &&  (buffer1[19]=='#'))
       {
         // attendu :      U;04;06;14;04;19;59#
         UART1_Write_CText("RTC MAJ au format  U;28;12;16;04;19;59# \r\n");
         MAJ_RTC();
            // Date[12];     // dd/mm/20yy\0
            // Time[9];      // hh:mn:ss\0
          Read_Date_Time(&sec,&min1,&hr,&week_day,&day,&month,&year);      // read time from RTC(DS1307)
          Transform_Time(&sec,&min1,&hr,&week_day,&day,&month,&year); // format date and time
          Prepare_Display_Time( sec, min1,hr, week_day,  day, month,  year );
          UART1_Write_CText("New DS1307 Date :");
          UART1_Write_Text(Date);
          UART1_Write_CText(" New Time: ");
          UART1_Write_Text(Time);
          CRLF1();
          *(buffer1)=0 ;
        p=0;
      }
     p= strstr(buffer1,"DEMO");  // p pointer result
     if (p>0)
     {
       UART1_Write_CText("Affiche Messages 0  15  stockes en EEPROM du PIC18F \r\n" )   ;
       for (i=0;i<15;i++)
       {
       k=i<<6;
       Read_Msg64_Eeprom(txt,k);
       UART1_Write_CText("Eeprom # ");
       WordToHex(k,CRam1);UART1_Write_Text(CRam1);UART1_Write(TAB);
       UART1_Write_Text(txt);    CRLF1();
       Affiche_Text_Matrice(txt, 25);
       Delay_ms(1000);
       }
     }//p

      RAZ_UART1();
     } // flag
   }
 }
 
 /*


Presentation :
 Mikroc 7.0.0 18F46K22
 Directory : C:_MikroC_MesProjets_MikroC_Max7219_4_matrice8x8
 Projet : 18F46K22_MAX7219_4x_Mat_8x8_SPI1_Softw_LM335.mcppir
 Source : 18F46K22_test_Max71219_4xMatrice8x8_SOFT_SPI_LM335_161230.c
 Module Matrice 8x8 avec MAX7129 + capteur LM335
 Saisir un nouveau Msg avec le terminal via <Msg=xxxx>
 Mode Temperature avec <TEMP_ON> ou <TEMP_OFF>


Clock initiale in  = 16000 Khz
Init I2C2 400Khz pour RTC DS1307
DS1307 Date :31/12/2016 Time: 14:01:01
Date &t1 debut 2016/12/30 23H59M00S =1483142340
Date &t2  Fin  2017/01/01 00H00M00S= 1483228800
Difference =     86460
init ADC EA0 et -VREF=2,5V sur RA2
init SOFT SPI  RC3=Clk ,RC5=Dout  RC0=CS -> MAx7219:
Clear Matrice 2x 8x8
Init et test interrupt Timer1  8 x 125 msec soit 2 sec
$
#
Display <0123456789> sur matrices Leds
J=   0  Date &t1 Now 31/12/2016 14:01:10 =>:1483192870
Date &T2 Fin = 31/12/16 23:59:59 => : 1483228799
                      Difference =>35929
J=   1  Date &t1 Now 31/12/2016 14:01:23 =>:1483192883
Date &T2 Fin = 31/12/16 23:59:59 => : 1483228799
                      Difference =>35916
                      
                      
                      
                      
                      
                      
                      
                      
                      
                      
                      
                      
                      
                      
                      
                      
                      
                      
                      
 
 Presentation :
 Mikroc 7.0.0 18F46K22
 Directory : C:_MikroC_MesProjets_MikroC_Max7219_4_matrice8x8
 Projet : 18F46K22_MAX7219_4x_Mat_8x8_SPI1_Softw_LM335.mcppir
 Source : 18F46K22_test_Max71219_4xMatrice8x8_SOFT_SPI_LM335_161229.c
 Module Matrice 8x8 avec MAX7129 + capteur LM335
 Saisir un nouveau Msg avec le terminal via <Msg=xxxx>
 Mode Temperature avec <TEMP_ON> ou <TEMP_OFF>


Clock initiale in  =  8000 Khz
Init I2C2 100Khz pour RTC DS1307
DS1307 Date :31/12/2016 Time: 23:59:00
Date &t1 debut 2016/12/30 23H59M00S =1483142340
Date &t2  Fin  2017/01/01 00H00M00S= 1483228800
Difference =     86460
init ADC EA0 et -VREF=2,5V sur RA2
init SOFT SPI  RC3=Clk ,RC5=Dout  RC0=CS -> MAx7219:
Clear Matrice 2x 8x8
Init et test interrupt Timer1  8 x 125 msec soit 2 sec
$
#
Display <0123456789> sur matrices Leds
J=   0  T=  166 pts  21.2C
Date &t1 Now 31/12/2016 23:59:11 =>:1483228751
Date &T2 Fin = 31/12/16 23:59:59 => : 1483228799
                      Difference =>48
reste : 48 S
J=   1  T=  166 pts  21.2C
Date &t1 Now 31/12/2016 23:59:15 =>:1483228755
Date &T2 Fin = 31/12/16 23:59:59 => : 1483228799
                      Difference =>44

....

reste : 8 S
J=  11  T=  166 pts  21.2C
Date &t1 Now 31/12/2016 23:59:55 =>:1483228795
Date &T2 Fin = 31/12/16 23:59:59 => : 1483228799
                      Difference =>4
J=  12  T=  166 pts  21.2C
Date &t1 Now 01/01/2017 00:00:08 =>:1483228808
Date &T2 Fin = 31/12/16 23:59:59 => : 1483228799
                      Difference =>-9
    Bonne Annee 2017.Bonne Sante.Bisous




DS1307 Date :01/01/2017 Time: 00:00:00
DS1307 Date :01/01/2017 Time: 00:00:02
DS1307 Date :01/01/2017 Time: 00:00:04
DS1307 Date :01/01/2017 Time: 00:00:06

     31/12/2016 23:59:12
       U;31;11;16;02;23;57#
       RTC MAJ au format  U;28;12;16;04;19;59#
       20
       Mise a l'heure RTC :U;31;11;16;02;23;57#
       Saisie :
       31
       11
       16
       2
       23
       57
       RTC Updated
       New DS1307 Date :31/11/2016 New Time: 23:57:00
       J=   1  T=  170 pts  22.2C


Presentation :
 Mikroc 7.0.0 18F46K22
 Directory : C:_MikroC_MesProjets_MikroC_Max7219_4_matrice8x8
 Projet : 18F46K22_MAX7219_4x_Mat_8x8_SPI1_Softw_LM335.mcppir
 Source : 18F46K22_test_Max71219_4xMatrice8x8_SOFT_SPI_LM335_161224.c
 Module Matrice 8x8 avec MAX7129 + capteur LM335
 Saisir un nouveau Msg avec le terminal via <Msg=xxxx>
 Mode Temperature avec <TEMP_ON> ou <TEMP_OFF>
Messages en EEPROM avec cde : <EEPROM=0> ..  15


Clock initiale in  =  8000 Khz
init ADC EA0 et -VREF=2,5V sur RA2
init SOFT SPI  RC3=Clk ,RC5=Dout  RC0=CS -> MAx7219:
Clear Matrice 2x 8x8
Init et test interrupt Timer1  8 x 125 msec soit 2 sec
$
#
Display <0123456789> sur matrices Leds
Message 8 : *JOYEUX NOEL a mes Amours*
*JOYEUX NOEL a mes Amours*
 Bonne Annee 2017
*JOYEUX NOEL a mes Amours*
 Bonne Annee 2017


J=   1  Tamb=17.8C
~*~JOYEUX NOEL~*~
J=   3  Tamb=17.8C


      0 1 mikroCPIC1618.exe -MSF -DBG -pP18F46K22 -RA -C -O00001104 -fo8 -N"C:\_MikroC\_MesProjets_MikroC\_Max7219_4_matrice8x8\18F46K22_MAX7219_4x_Mat_8x8_SPI1_Softw_LM335.mcppi" -EH"C:\_MikroC\_MesProjets_MikroC\_Max7219_4_matrice8x8\18F46K22_MAX7219_4x_Mat_8x8_SPI1_Softw_EEPROM.ihex" -SP"C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"C:\_MikroC\mikroC PRO for PIC\uses\P18\" -SP"C:\_MikroC\_MesProjets_MikroC\_Max7219_4_matrice8x8\" -IP"C:\_MikroC\_MesProjets_MikroC\_Max7219_4_matrice8x8\" "_18F46K22_test_Max71219_4xMatrice8x8_SOFT_SPI_LM335_161224.c" "__Lib_Math.mcl" "__Lib_MathDouble.mcl" "__Lib_System.mcl" "__Lib_Delays.mcl" "__Lib_CType.mcl" "__Lib_CString.mcl" "__Lib_CStdlib.mcl" "__Lib_Conversions.mcl" "__Lib_SoftSPI.mcl" "__Lib_ADC_K22_B.mcl" "__Lib_EEPROM_1024.mcl" "__Lib_I2C_c34d01.mcl" "__Lib_UART_c67d67.mcl"
0 1139 Available RAM: 3875 [bytes], Available ROM: 65536 [bytes]
0 122 Compilation Started P18F46K22.c
2781 123 Compiled Successfully P18F46K22.c
0 122 Compilation Started __Lib_Delays.c
172 123 Compiled Successfully __Lib_Delays.c
0 122 Compilation Started _18F46K22_test_Max71219_4xMatrice8x8_SOFT_SPI_LM335_161224.c
0 1004 interrupt handler (Interrupt_High at 0x0008) interruptions.h
0 1004 interrupt handler (Interrupt_LOW at 0x0018) interruptions.h
539 1509 Generated baud rate is 19231 bps (error = 0.16 percent) _18F46K22_test_Max71219_4xMatrice8x8_SOFT_SPI_LM335_161224.c
862 123 Compiled Successfully _18F46K22_test_Max71219_4xMatrice8x8_SOFT_SPI_LM335_161224.c
426 1164 Variable 'Ex' has been eliminated by optimizer _18F46K22_test_Max71219_4xMatrice8x8_SOFT_SPI_LM335_161224.c
113 1164 Variable 'c1' has been eliminated by optimizer _18F46K22_test_Max71219_4xMatrice8x8_SOFT_SPI_LM335_161224.c
0 127 All files Compiled in 172 ms
0 1144 Used RAM (bytes): 589 (15%)  Free RAM (bytes): 3286 (85%) Used RAM (bytes): 589 (15%)  Free RAM (bytes): 3286 (85%)
0 1144 Used ROM (bytes): 13529 (21%)  Free ROM (bytes): 52007 (79%) Used ROM (bytes): 13529 (21%)  Free ROM (bytes): 52007 (79%)
0 125 Project Linked Successfully 18F46K22_MAX7219_4x_Mat_8x8_SPI1_Softw_LM335.mcppi
0 128 Linked in 109 ms
0 129 Project '18F46K22_MAX7219_4x_Mat_8x8_SPI1_Softw_LM335.mcppi' completed: 531 ms
0 103 Finished successfully: 24 dc. 2016, 15:43:56 18F46K22_MAX7219_4x_Mat_8x8_SPI1_Softw_LM335.mcppi


*/